﻿
Imports System
Imports System.Text
Imports System.Runtime.InteropServices

Public Class classFtMscLib

    '*** List of var

    Public Const dllpath As String = "C:\windows\system32\ftMscLib.dll"

    'Alternatively to original Fischertechnik ditributes library 'ftMscLib.dll' the following can be used with additional 
    'function set, but it is necessarry to install VS C++ VS2012 reditributable x86 befor on the system
    'Public Const dllpath As String = "C:\windows\system32\ftMscLibEx.dll"


    '*** List of declarations
    Public Class FtLibDeclarations

        <DllImport(dllpath, EntryPoint:="ftxGetLibVersionStr", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxGetLibVersionStr(<MarshalAs(UnmanagedType.LPStr)> ByVal Foo2 As StringBuilder, ByVal len As UInteger) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="ftxGetLibVersion", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxGetLibVersion() As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="ftxIsTransferActiv", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxIsTransferActiv(ByVal fthdl As UInteger) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="GetAvailableComPorts", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxGetAvailableComPorts(ByVal selectMode As Integer) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="EnumComPorts", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxEnumComPorts(ByVal idx As UInteger, <MarshalAs(UnmanagedType.LPStr)> ByVal comstr As StringBuilder, ByVal len As UInteger) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="ftxOpenComDevice", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxOpenComDevice(ByVal comStr As String, ByVal bdr As UInteger, ByRef uint As UInteger) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="ftxOpenComDeviceNr", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxOpenComDeviceNr(ByVal comStr As UInteger, ByVal bdr As UInteger, ByRef uint As UInteger) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="ftxInitLib", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxInitLib() As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="ftxIsLibInit", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxIsLibInit() As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="ftxIsHandleValid", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxIsHandleValid(ByVal fthdl As UInteger) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="GetComStatus", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxGetComStatus(ByVal fthdl As UInteger) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="ftxCloseLib", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxCloseLib() As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="ftxGetLibErrorString", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxGetLibErrorString(ByVal errCode As UInteger, ByVal typ As UInteger, <MarshalAs(UnmanagedType.LPStr)> ByVal buff As StringBuilder, ByVal maxLen As UInteger) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="ftxCloseDevice", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxCloseDevice(ByVal fthdl As UInteger) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="ftxStartTransferArea", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxStartTransferArea(ByVal fthdl As UInteger) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="ftxStopTransferArea", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxStopTransferArea(ByVal fthdl As UInteger) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="SetOutMotorValues", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxSetOutMotorValues(ByVal fthdl As UInteger, ByVal shmId As Integer, ByVal id As Integer, ByVal duty_p As Integer, ByVal duty_m As Integer, ByVal brake As Boolean) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="SetFtMotorConfig", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxSetOutMotorConfig(ByVal fthdl As UInteger, ByVal shmId As Integer, ByVal id As Integer, ByVal status As Boolean) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="SetFtUniConfig", CallingConvention:=CallingConvention.Cdecl)>
        Public Shared Function ftxSetUniConfig(ByVal fthdl As UInteger, ByVal shmId As Integer, ByVal id As Integer, ByVal mode As Integer, ByVal status As Boolean) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="GetInIOValue", CallingConvention:=CallingConvention.Cdecl)>
        Public Shared Function ftxGetInIOValue(ByVal fthdl As UInteger, ByVal shmId As Integer, ByVal idx As Integer, ByRef valRef As Short, ByRef overrunRef As Boolean) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="StartCounterReset", CallingConvention:=CallingConvention.Cdecl)>
        Public Shared Function ftxStartCounterReset(ByVal fthdl As UInteger, ByVal shmId As Integer, ByVal idx As Integer) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="GetInCounterValue", CallingConvention:=CallingConvention.Cdecl)>
        Public Shared Function ftxGetInCounterValue(ByVal fthdl As UInteger, ByVal shmId As Integer, ByVal idx As Integer, ByRef contRef As UShort, ByRef valRef As UShort) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="GetInDisplayButtonValue", CallingConvention:=CallingConvention.Cdecl)>
        Public Shared Function ftxGetInDisplayButtonValue(ByVal fthdl As UInteger, ByVal shmId As Integer, ByRef leftRef As UShort, ByRef rightRef As UShort) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="SetRoboTxMessage", CallingConvention:=CallingConvention.Cdecl)>
        Public Shared Function ftxSetRoboTxMessage(ByVal fthdl As UInteger, ByVal shmId As Integer, ByVal msg As String) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="GetRoboTxDevName", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxGetRoboTxDevName(ByVal fthdl As UInteger, ByVal shmId As Integer, <MarshalAs(UnmanagedType.LPStr)> ByVal buff As StringBuilder, ByVal maxLen As UInteger) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="ftxGetSerialNrStrg", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxGetSerialNrStrg(ByVal fthdl As UInteger, <MarshalAs(UnmanagedType.LPStr)> ByVal buff As StringBuilder, ByVal maxLen As UInteger) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="GetRoboTxFwStr", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxGetRoboTxFwStr(ByVal fthdl As UInteger, ByVal shmId As Integer, <MarshalAs(UnmanagedType.LPStr)> ByVal buff As StringBuilder, ByVal maxLen As UInteger) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="GetRoboTxHwStr", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxGetRoboTxHwStr(ByVal fthdl As UInteger, ByVal shmId As Integer, <MarshalAs(UnmanagedType.LPStr)> ByVal buff As StringBuilder, ByVal maxLen As UInteger) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="GetRoboTxDllStr", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxGetRoboTxDllStr(ByVal fthdl As UInteger, ByVal shmId As Integer, <MarshalAs(UnmanagedType.LPStr)> ByVal buff As StringBuilder, ByVal maxLen As UInteger) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="ftxGetManufacturerStrg", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxGetManufacturerStrg(ByVal fthdl As UInteger, <MarshalAs(UnmanagedType.LPStr)> ByVal buff As StringBuilder, ByVal maxLen As UInteger) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="ftxGetShortNameStrg", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxGetShortNameStrg(ByVal fthdl As UInteger, <MarshalAs(UnmanagedType.LPStr)> ByVal buff As StringBuilder, ByVal maxLen As UInteger) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="ftxGetLongNameStrg", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxGetLongNameStrg(ByVal fthdl As UInteger, <MarshalAs(UnmanagedType.LPStr)> ByVal buff As StringBuilder, ByVal maxLen As UInteger) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="GetRoboTxSerialStr", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxGetRoboTxSerialStr(ByVal fthdl As UInteger, ByVal shmId As Integer, <MarshalAs(UnmanagedType.LPStr)> ByVal buff As StringBuilder, ByVal maxLen As UInteger) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="GetRoboTxFwVal", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxGetRoboTxFwVal(ByVal fthdl As UInteger, ByVal shmId As Integer, ByRef versionRef As UInteger) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="GetRoboTxInfo", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxGetRoboTxInfo(ByVal fthdl As UInteger, ByVal shmId As Integer) As UInteger
        End Function

        <DllImport(dllpath, EntryPoint:="GetSessionId", CallingConvention:=CallingConvention.Cdecl)> _
        Public Shared Function ftxGetSessionId() As UInteger
        End Function





    End Class

    '*** List of codes
    Public Class FtLibConst

        Public Const FTLIB_ERR_SUCCESS As UInteger = &H0UI
        Public Const FTLIB_ERR_NO_MEMORY As UInteger = &HE0000100UI

        Public Const FTLIB_ERR_FAILED As UInteger = &HE0001000UI
        Public Const FTLIB_ERR_TIMEOUT As UInteger = &HE000100CUI
        Public Const FTLIB_ERR_INVALID_PARAM As UInteger = &HE0001018UI

        Public Const FTLIB_ERR_SOME_DEVICES_ARE_OPEN As UInteger = &HE0001101UI
        Public Const FTLIB_ERR_DEVICE_IS_OPEN As UInteger = &HE0001102UI
        Public Const FTLIB_ERR_DEVICE_NOT_OPEN As UInteger = &HE0001103UI
        Public Const FTLIB_ERR_NO_SUCH_DEVICE_INSTANCE As UInteger = &HE0001104UI

        Public Const FTLIB_ERR_UNKNOWN_DEVICE_HANDLE As UInteger = &HE0001283UI
        Public Const FTLIB_ERR_LIB_IS_INITIALIZED As UInteger = &HE0001286UI
        Public Const FTLIB_ERR_LIB_IS_NOT_INITIALIZED As UInteger = &HE0001287UI
        Public Const FTLIB_ERR_THREAD_NOT_STARTABLE As UInteger = &HE00012A0UI
        Public Const FTLIB_ERR_THREAD_IS_RUNNING As UInteger = &HE00012A5UI
        Public Const FTLIB_ERR_THREAD_NOT_RUNNING As UInteger = &HE00012A6UI
        Public Const FTLIB_ERR_THREAD_SYNCHRONIZED As UInteger = &HE00012AFUI

        Public Const FTLIB_ERR_TIMEOUT_TA As UInteger = &HE00012B0UI
        Public Const FTLIB_ERR_CREATE_EVENT As UInteger = &HE00012B1UI
        Public Const FTLIB_ERR_CREATE_MM_TIMER As UInteger = &HE00012B2UI

        Public Const FTLIB_ERR_UPLOAD_FILE_NOT_OPEN As UInteger = &HE0001400UI
        Public Const FTLIB_ERR_UPLOAD_FILE_READ_ERR As UInteger = &HE0001401UI
        Public Const FTLIB_ERR_UPLOAD_INVALID_FSIZE As UInteger = &HE0001402UI
        Public Const FTLIB_ERR_UPLOAD_START As UInteger = &HE0001403UI
        Public Const FTLIB_ERR_UPLOAD_CANCELED As UInteger = &HE0001404UI
        Public Const FTLIB_ERR_UPLOAD_FAILED As UInteger = &HE0001405UI
        Public Const FTLIB_ERR_UPLOAD_TIMEOUT As UInteger = &HE0001406UI
        Public Const FTLIB_ERR_UPLOAD_ACK As UInteger = &HE0001407UI
        Public Const FTLIB_ERR_UPLOAD_NAK As UInteger = &HE0001408UI
        Public Const FTLIB_ERR_UPLOAD_DONE As UInteger = &HE0001409UI
        Public Const FTLIB_ERR_UPLOAD_FLASHWRITE As UInteger = &HE000140AUI
        Public Const FTLIB_ERR_REM_CMD_FAILED As UInteger = &HE000140BUI
        Public Const FTLIB_ERR_REM_CMD_NOT_SUPPORTED As UInteger = &HE000140CUI
        Public Const FTLIB_ERR_FWUPD_GET_FILES As UInteger = &HE000140DUI
        Public Const FTLIB_ERR_FWUPD_NO_FILES As UInteger = &HE000140EUI

        Public Const FTLIB_ERR_ACCESS_DENIED As UInteger = &HE0001905UI
        Public Const FTLIB_ERR_OPEN_COM As UInteger = &HE0001906UI
        Public Const FTLIB_ERR_INIT_COM As UInteger = &HE0001908UI
        Public Const FTLIB_ERR_INIT_COM_TIMEOUT As UInteger = &HE0001909UI

        Public Const FTLIB_ERR_WRONG_HOSTNAME_LEN As UInteger = &HE0002000UI

        Public Const FTLIB_FWUPD_UPLOAD_START As UInteger = &HE0003000UI
        Public Const FTLIB_FWUPD_UPLOAD_DONE As UInteger = &HE0003001UI
        Public Const FTLIB_FWUPD_TIMEOUT As UInteger = &HE0003002UI
        Public Const FTLIB_FWUPD_FLUSH_DISK As UInteger = &HE0003003UI
        Public Const FTLIB_FWUPD_CLEAN_DISK As UInteger = &HE0003004UI
        Public Const FTLIB_FWUPD_ERR_FILE_READ As UInteger = &HE0003005UI
        Public Const FTLIB_FWUPD_UPLOAD_FAILED As UInteger = &HE0003006UI
        Public Const FTLIB_FWUPD_STARTING As UInteger = &HE0003007UI
        Public Const FTLIB_FWUPD_FINISHED As UInteger = &HE0003008UI
        Public Const FTLIB_FWUPD_REM_COMMAND As UInteger = &HE0003009UI
        Public Const FTLIB_FWUPD_REM_TIMEOUT As UInteger = &HE000300AUI
        Public Const FTLIB_FWUPD_REM_FAILED As UInteger = &HE000300BUI
        Public Const FTLIB_FWUPD_IZ_STEPS As UInteger = &HE000300CUI
        Public Const FTLIB_FWUPD_STEP As UInteger = &HE000300DUI

        Public Const FTLIB_BT_INVALID_CONIDX As UInteger = &HE0004000UI
        Public Const FTLIB_BT_CON_NOT_EXISTS As UInteger = &HE0004001UI
        Public Const FTLIB_BT_CON_ACTIVE As UInteger = &HE0004002UI
        Public Const FTLIB_BT_CON_INACTIVE As UInteger = &HE0004003UI
        Public Const FTLIB_BT_CON_WRONG_ADDR As UInteger = &HE0004004UI
        Public Const FTLIB_BT_CON_WAIT_BUSY As UInteger = &HE0004005UI

        Public Const FTLIB_I2C_INVALID_DEV_ADDR As UInteger = &HE0005000UI
        Public Const FTLIB_I2C_INVALID_FLAGS_ADDRMODE As UInteger = &HE0005001UI
        Public Const FTLIB_I2C_INVALID_FLAGS_DATAMODE As UInteger = &HE0005002UI
        Public Const FTLIB_I2C_INVALID_FLAGS_ERRMODE As UInteger = &HE0005003UI

        Public Const FTLIB_ERR_UNKNOWN As UInteger = &HEFFFFFFFUI

        'used for GetAvailableComPorts
        Public Const ALL_PORTS As Integer = 0
        Public Const USB_ONLY As Integer = 1
        Public Const BT_ONLY As Integer = 2

        'used for transfer area (TA)
        Public Const TA_STATUS_STOP As Integer = 0
        Public Const TA_STATUS_RUN As Integer = 1
        Public Const TA_STATUS_SYNC As Integer = 2


        'used for I/O communication
        Public Const SE_REMIO_REQ As Integer = 0
        Public Const SE_CONFIG_REQ As Integer = 1

        ' used for multi-controller-mode status (slave)
        Public Const SLAVE_OFFLINE As Integer = 0
        Public Const SLAVE_ONLINE As Integer = 1

        'used for SetRoboTxMessage
        Public Const ROBOTXC_MASTER As Integer = 0
        Public Const ROBOTXC_SLAVE1 As Integer = 1
        Public Const ROBOTXC_SLAVE2 As Integer = 2
        Public Const ROBOTXC_SLAVE3 As Integer = 3
        Public Const ROBOTXC_SLAVE4 As Integer = 4
        Public Const ROBOTXC_SLAVE5 As Integer = 5
        Public Const ROBOTXC_SLAVE6 As Integer = 6
        Public Const ROBOTXC_SLAVE7 As Integer = 7
        Public Const ROBOTXC_SLAVE8 As Integer = 8

        'used for motor management
        Public Const ROBOTXC_M1 As Integer = 0
        Public Const ROBOTXC_M2 As Integer = 1
        Public Const ROBOTXC_M3 As Integer = 2
        Public Const ROBOTXC_M4 As Integer = 3
        Public Const ROBOTXC_MODE_MOTOR As Boolean = True
        Public Const ROBOTXC_MODE_SINGLEOUT As Boolean = False
        Public Const ROBOTXC_MODE_BRAKE As Boolean = True
        Public Const ROBOTXC_MODE_RUN As Boolean = False


        'used for input management
        Public Const ROBOTXC_I1 As Integer = 0
        Public Const ROBOTXC_I2 As Integer = 1
        Public Const ROBOTXC_I3 As Integer = 2
        Public Const ROBOTXC_I4 As Integer = 3
        Public Const ROBOTXC_I5 As Integer = 4
        Public Const ROBOTXC_I6 As Integer = 5
        Public Const ROBOTXC_I7 As Integer = 6
        Public Const ROBOTXC_I8 As Integer = 7
        Public Const ROBOTXC_MODE_VOLTAGE As Integer = 0
        Public Const ROBOTXC_MODE_RESISTANCE As Integer = 1
        Public Const ROBOTXC_MODE_SUPERSONIC As Integer = 3
        Public Const ROBOTXC_MODE_DIGITAL As Boolean = True
        Public Const ROBOTXC_MODE_ANALOG As Boolean = False

    End Class

End Class

