﻿
Module modMainWC001

    Sub WorkingCycle001()

        '**********************************************************************************************
        '*** serial function chain working cycle 1
        '**********************************************************************************************

        'Debug.Print("WC001 main runnng... " & Now())


        '*** variable declaration

        Dim errCode1 As UInteger        'error code
        Dim valRefI1 As Short           'status input pis I1
        Dim valRefI2 As Short           'status input pis I2
        Dim valRefI3 As Short           'status input pis I3
        Dim valRefI4 As Short           'status input pis I4
        Dim valRefI5 As Short           'status input pis I5
        Dim valRefI6 As Short           'status input pis I6
        Dim valRefI7 As Short           'status input pis I7
        Dim valRefI8 As Short           'status input pis I8
        Dim overrunRef As Boolean       'not used


        '*** check if init of working cycle 1 has to be done first

        If glWC001FirstLoop = True Then
            glWC001FirstLoop = False
            WorkingCycle001Init()
        End If


        '*** read relevant input status, result is stored under valRefIx, overrunRef not used

        errCode1 = classFtMscLib.FtLibDeclarations.ftxGetInIOValue(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_I1, valRefI1, overrunRef)
        errCode1 = classFtMscLib.FtLibDeclarations.ftxGetInIOValue(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_I2, valRefI2, overrunRef)
        errCode1 = classFtMscLib.FtLibDeclarations.ftxGetInIOValue(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_I3, valRefI3, overrunRef)
        errCode1 = classFtMscLib.FtLibDeclarations.ftxGetInIOValue(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_I4, valRefI4, overrunRef)
        errCode1 = classFtMscLib.FtLibDeclarations.ftxGetInIOValue(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_I5, valRefI5, overrunRef)
        errCode1 = classFtMscLib.FtLibDeclarations.ftxGetInIOValue(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_I6, valRefI6, overrunRef)
        errCode1 = classFtMscLib.FtLibDeclarations.ftxGetInIOValue(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_I7, valRefI7, overrunRef)
        errCode1 = classFtMscLib.FtLibDeclarations.ftxGetInIOValue(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_I8, valRefI8, overrunRef)

        'System.Windows.Forms.Application.DoEvents()


        '*** store data to array
        glDataColMax = glDataColMax + 1
        If valRefI1 = 0 Then glDataCol(glDataColMax, 1) = 0
        If valRefI1 = 1 Then glDataCol(glDataColMax, 1) = 100
        If valRefI2 = 0 Then glDataCol(glDataColMax, 2) = 0
        If valRefI2 = 1 Then glDataCol(glDataColMax, 2) = 100
        If valRefI3 = 0 Then glDataCol(glDataColMax, 3) = 0
        If valRefI3 = 1 Then glDataCol(glDataColMax, 3) = 100
        If valRefI4 = 0 Then glDataCol(glDataColMax, 4) = 0
        If valRefI4 = 1 Then glDataCol(glDataColMax, 4) = 100
        If valRefI5 = 0 Then glDataCol(glDataColMax, 5) = 0
        If valRefI5 = 1 Then glDataCol(glDataColMax, 5) = 100
        If valRefI6 = 0 Then glDataCol(glDataColMax, 6) = 0
        If valRefI6 = 1 Then glDataCol(glDataColMax, 6) = 100
        If valRefI7 = 0 Then glDataCol(glDataColMax, 7) = 0
        If valRefI7 = 1 Then glDataCol(glDataColMax, 7) = 100
        If valRefI8 = 0 Then glDataCol(glDataColMax, 8) = 0
        If valRefI8 = 1 Then glDataCol(glDataColMax, 8) = 100

        'Debug.Print("I/O Zustand " & glDataColMax & " : " & valRefI1 & valRefI2 & valRefI3 & valRefI4 & valRefI5 & valRefI6 & valRefI7 & valRefI8)


        '*** rewrite Display
        frmHello.WritePicFrame()


    End Sub

    Sub WorkingCycle001Init()

        '**********************************************************************************************
        '*** serial function chain working cycle 1, init when running the first loop
        '**********************************************************************************************

        'Debug.Print("WC001 init runnng... " & Now())


        '*** variable declaration

        Dim errCode1 As UInteger


        '*** define input pins of RoboTXController

        'send a message to operation log    
        frmHello.OperationLogAddItem("")
        frmHello.OperationLogAddItem("SFC:    doing WC001Init operation")

        'define input pin I1 as digital input 5kOhm
        errCode1 = classFtMscLib.FtLibDeclarations.ftxSetUniConfig(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_I1, classFtMscLib.FtLibConst.ROBOTXC_MODE_RESISTANCE, classFtMscLib.FtLibConst.ROBOTXC_MODE_DIGITAL)

        'define input pin I2 as digital input 5kOhm
        errCode1 = classFtMscLib.FtLibDeclarations.ftxSetUniConfig(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_I2, classFtMscLib.FtLibConst.ROBOTXC_MODE_RESISTANCE, classFtMscLib.FtLibConst.ROBOTXC_MODE_DIGITAL)

        'define input pin I3 as digital input 5kOhm
        errCode1 = classFtMscLib.FtLibDeclarations.ftxSetUniConfig(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_I3, classFtMscLib.FtLibConst.ROBOTXC_MODE_RESISTANCE, classFtMscLib.FtLibConst.ROBOTXC_MODE_DIGITAL)

        'define input pin I4 as digital input 5kOhm
        errCode1 = classFtMscLib.FtLibDeclarations.ftxSetUniConfig(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_I4, classFtMscLib.FtLibConst.ROBOTXC_MODE_RESISTANCE, classFtMscLib.FtLibConst.ROBOTXC_MODE_DIGITAL)

        'define input pin I5 as digital input 5kOhm
        errCode1 = classFtMscLib.FtLibDeclarations.ftxSetUniConfig(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_I5, classFtMscLib.FtLibConst.ROBOTXC_MODE_RESISTANCE, classFtMscLib.FtLibConst.ROBOTXC_MODE_DIGITAL)

        'define input pin I6 as digital input 5kOhm
        errCode1 = classFtMscLib.FtLibDeclarations.ftxSetUniConfig(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_I6, classFtMscLib.FtLibConst.ROBOTXC_MODE_RESISTANCE, classFtMscLib.FtLibConst.ROBOTXC_MODE_DIGITAL)

        'define input pin I7 as digital input 5kOhm
        errCode1 = classFtMscLib.FtLibDeclarations.ftxSetUniConfig(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_I7, classFtMscLib.FtLibConst.ROBOTXC_MODE_RESISTANCE, classFtMscLib.FtLibConst.ROBOTXC_MODE_DIGITAL)

        'define input pin I8 as digital input 5kOhm
        errCode1 = classFtMscLib.FtLibDeclarations.ftxSetUniConfig(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_I8, classFtMscLib.FtLibConst.ROBOTXC_MODE_RESISTANCE, classFtMscLib.FtLibConst.ROBOTXC_MODE_DIGITAL)

    End Sub

End Module
